import javax.swing.*; 
import javax.swing.border.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.util.*; 
import java.io.*; 
import PanelPelicula;  

public class videoAdmin extends JFrame 
{
PanelPelicula[] pp = new PanelPelicula[100];
JButton[] bp = new JButton[100];
JScrollPane sp;
JPanel jp;
JButton Actualizar;
JButton Deshacer;
JButton Nuevo;
int numvideos=0;
String archivo;

 public videoAdmin(String name,String arch) 
   {
   super(name);
   archivo=arch;
   jp = new JPanel();
   sp = new JScrollPane(jp);
   sp.setPreferredSize(new Dimension(700,420));
   jp.setLayout(new FlowLayout());
   sp.setVerticalScrollBarPolicy(sp.VERTICAL_SCROLLBAR_ALWAYS);
   sp.setHorizontalScrollBarPolicy(sp.HORIZONTAL_SCROLLBAR_NEVER);
   Actualizar = new JButton("Actualizar",new ImageIcon("A.gif"));
   Actualizar.addActionListener(AActualizar);
   Deshacer = new JButton("Deshacer",new ImageIcon("D.gif"));
   Deshacer.addActionListener(ADeshacer);
   Nuevo = new JButton("Nuevo",new ImageIcon("N.gif"));
   Nuevo.addActionListener(ANuevo);
   Container cp = getContentPane();
   cp.setLayout(new FlowLayout());
   cp.add(Actualizar);
   cp.add(Deshacer);
   cp.add(Nuevo);
   cp.add(sp);
   numvideos=LeeArchivo();
   }

 public static void main(String[] args)
   {
   if (args.length < 1)
      {
      System.out.println("ERROR: Chequee parametros");
      return;
      }
   JFrame frame = new videoAdmin("videoAdmin",args[0]);
   frame.addWindowListener(
          new WindowAdapter() {
             public void windowClosing(WindowEvent e)
               {
               System.exit(0);
               }
            });
   frame.setSize(750,500);
   frame.setVisible(true);
   frame.setResizable(false);
   }  

 public int LeeArchivo()
   {
   int i=0;
   String linea;
   jp.removeAll();
   try
      {
      BufferedReader d = new BufferedReader(new FileReader(archivo));
   
      while ((linea = d.readLine()) != null)
         {
         pp[i] = new PanelPelicula(linea);
         bp[i] = new JButton(new ImageIcon("X.gif"));
         jp.add(pp[i]);
         jp.add(bp[i]);
         bp[i].addActionListener(ABorrar);
         i++;
         }
      d.close();
      } 
       catch (Exception e) {}
   jp.setPreferredSize(new Dimension(680,(int)(5+i*(5+pp[0].getPreferredSize().getHeight()))));
   return i;
   }

 public void EscribeArchivo()
   {
   try
      {
      BufferedWriter d = new BufferedWriter(new FileWriter(archivo));
   
      for(int i=0;i<numvideos;i++)
         {
         d.write(pp[i].info());
         d.newLine();
         }
      d.close();
      }
       catch (Exception e) {}
   }

ActionListener AActualizar =
    new ActionListener()
      {
       public void actionPerformed(ActionEvent evento)
         {
         EscribeArchivo();
         }
      };

ActionListener ADeshacer =
    new ActionListener()
      {
       public void actionPerformed(ActionEvent evento)
         {
         numvideos=LeeArchivo();
         jp.setPreferredSize(new Dimension(680,(int)(5+numvideos*(5+pp[0].getPreferredSize().getHeight()))));
         jp.updateUI();
         }
      };
ActionListener ANuevo =
    new ActionListener()
      {
       public void actionPerformed(ActionEvent evento)
         {
         pp[numvideos] = new PanelPelicula("^^");
         bp[numvideos] = new JButton(new ImageIcon("X.gif"));
         bp[numvideos].addActionListener(ABorrar);
         jp.add(pp[numvideos]);
         jp.add(bp[numvideos]);
         numvideos++;
         jp.setPreferredSize(new Dimension(680,(int)(5+numvideos*(5+pp[0].getPreferredSize().getHeight()))));
         jp.updateUI();
         }
      };
ActionListener ABorrar = 
    new ActionListener()
      {
       public void actionPerformed(ActionEvent evento)
         {
         int index=(int)(((JButton)(evento.getSource())).getY()-16)/52;
         numvideos--;
      
         for (int i=index;i<numvideos;i++)
            {
            jp.remove(bp[i]);
            jp.remove(pp[i]);
            bp[i]=bp[i+1];
            pp[i]=pp[i+1];
            }
         jp.remove(bp[numvideos]);
         jp.remove(pp[numvideos]);
      
         for (int i=index;i<numvideos;i++)
            {
            jp.add(pp[i]);
            jp.add(bp[i]);
            }
         jp.setPreferredSize(new Dimension(680,(int)(5+numvideos*(5+pp[0].getPreferredSize().getHeight()))));
         jp.updateUI();
         }
      };
}

class MyActionListener implements ActionListener 
{ 
JTextField _t; 
 public MyActionListener (JTextField t) 
   {
   _t = t;
   }

 public void actionPerformed(ActionEvent e)
   {
   String name = ((JButton)e.getSource()).getText();
   _t.setText(name);
   }
}